Ext.define('DSS.component.Signal', {
	extend : 'DSS.component.Base',
	mixins : {
		observable : 'Ext.util.Observable'
	},
	myID:null,
	constructor: function (config) {
		this.myID=config.id;
		lbl = Ext.create('Ext.form.field.Display',{
			fieldLabel: config.fieldlabel,
            width:150			
		}); 

		this.group=Ext.create('Ext.form.RadioGroup', {
            columns:1,
            width:175,
            items: [
                    {style:{color:'#005138','margin-bottom':0},boxLabel:_('Turn display on'),name:'baseValue_' + this.myID,inputValue:0},
                    {style:{color:'#005138','margin-bottom':0},boxLabel:_('Show event'),name:'baseValue_' + this.myID,inputValue:1},
                    {style:{color:'#005138'},boxLabel:_('Show event and blink'),name:'baseValue_' + this.myID,inputValue:2}
            ]
        });
		this.ckbSound=Ext.create('Ext.form.field.Checkbox', {
			style:{color:'#005138'},
            boxLabel:_('Play acustic sound'),
            allowBlank : true
        });
		
		var basePanel = Ext.create('Ext.panel.Panel', {
			border : '0',
			border : false,
			width:525,
			padding : '5 0 0 5',
			layout : {
				type : 'hbox'
			},
			height:90,
			items : [lbl,this.group,this.ckbSound]
		});

		var me = this;	
		
		Ext.apply(this, {
			items : [ basePanel ]
		});
	
		this.callParent(arguments);
	},
    getValue:function () {
    	var value;
    	switch(this.group.getValue()['baseValue_' +this.myID]) {
			case 0:
				value=0;
    		break;
			case 1:
				value=0x01
    		break;
			case 2:
				value=0x05
    		break;
    	}
    	if (this.ckbSound.getValue()) 
    		value|=0x02;
    	return value;
    },
    setValue:function (value) {
    	this.ckbSound.setValue((value & 0x02)>0);
    	var val={};
    	if ((value &0x04)>0) {    	
        	val['baseValue_' +this.myID]=2;
    	} else {
    		if ((value &0x01)>0) {
            	val['baseValue_' +this.myID]=1;
    		} else {
            	val['baseValue_' +this.myID]=0;
    		}
    	}
		this.group.setValue(val);
    }
})

Ext.define('DSS.component.SettingsEditor', {
    extend : 'Ext.window.Window',
    editControls: {},
    initStores: function ( ){
    	var arrayRooms = [];                                                             
        if (dss.staticDataModel.nameCache != null) {
        	for ( var iIndex = 0; iIndex < dss.staticDataModel.nameCache.length; iIndex++) {
        		var oZone = dss.staticDataModel.nameCache[iIndex];
        		if (oZone.ZoneID > 0) {
		             arrayRooms.push({"_id":oZone.ZoneID,
		                              "name":oZone.name,
		                              "passive":false});
           }
         } 
       } 
        if (Ext.data.StoreManager.lookup('generalSettingsZone') == null) {
 	       Ext.create('Ext.data.Store', {
 	            storeId : 'generalSettingsZone',
 	            fields : [ '_id', 'name', 'passive'],
 	            proxy : {
 	                type : 'memory',
 	                reader : {
 	                    type : 'json',
 	                    root : 'items'
 	                }
 	            },
 	            sorters: [{property: 'name',direction: 'ASC'}]
 	       });
         }
	    Ext.data.StoreManager.lookup('generalSettingsZone').removeAll();
	    Ext.data.StoreManager.lookup('generalSettingsZone').add(arrayRooms);
    },
    saveValues: function () {
    	var me=this;

    	if (this.dsid!=null) {
    		
    		if (this.editControls.nameEditor.isDirty())
	    		dss.ajaxAssyncRequestWithoutAnswer('/json/device/setName', {
	    			'newName' : this.editControls.nameEditor.getValue(),
	    			'dsuid' : this.dsid
	    		});
    		if (this.editControls.temperature.isDirty()) {
    			dss.raiseEvent('thanos.config',{
	    			actions:'calibrateSensor',
	    			dsid:this.dsid,
	    			realTemperature:this.editControls.temperature.getValue()});
         	   me.sensordsid="";
        	   me.sensorts=0;
    		}
    		var oParameter=[];
    		for (var sKey in this.editControls) {
    			if (this.editControls[sKey].deviceConfigValues!= null) {
    				var editDeviceIndex=this.editControls[sKey].deviceConfigValues.deviceIndex
    				var editBank=this.editControls[sKey].deviceConfigValues.bank;
    				var editIndex=this.editControls[sKey].deviceConfigValues.parameter;
    				var oObject={
    					bank:editBank,
    					index:editIndex,
    					deviceIndex:editDeviceIndex
    				};
					if (this.editControls[sKey].deviceConfigValues.bitmask!=null)
						oObject.bitmask=this.editControls[sKey].deviceConfigValues.bitmask;
										
					if (this.editControls[sKey].valueName!=null)
						oObject.value=this.editControls[sKey].getValue()[this.editControls[sKey].valueName];
					else
						oObject.value=this.editControls[sKey].getValue();
					oParameter.push(oObject);	
    			}				
    		}
    		
        	dss.raiseEvent('thanos.config',{
	    			actions:'setDeviceParameter',
	    			dsid:this.dsid,
	    			values:Ext.JSON.encode(oParameter)});        	
    	}
    },
    dsid:null,
    sensordsid:"",
    sensorts:0,
    lastSensorValue:0,
    setDSID:function (dsid) {
    	this.dsid=dsid;
    	this.fillControls();
    },
    fillTemperatureControl:function () {
    	this.editControls.temperature.setValue(null);
    	var baseIndex=Math.floor(parseInt(this.dsid.substring(this.dsid.length-3).substring(0,1),16)/8)*8;
		var parentDSID=this.dsid.substring(0,this.dsid.length-3);
		var sensordSID=parentDSID + '' + (baseIndex+1).toString(16) + "00";
		var me=this;
		var sensorDevice=dss.staticDataModel.getDevice(sensordSID);
		for (var iIndex=0;iIndex<sensorDevice.sensors.length;iIndex++) {
			if (sensorDevice.sensors[iIndex].type==9) {
				var fSkip=false;
				var nowTS=(new Date()).getTime();
				if (me.sensordsid==sensordSID)
					if ((me.sensorts + (1000*60*5))>nowTS)
						fSkip=true
				
				if (!fSkip) {
					this.sensordsid=sensordSID;
					this.sensorts=nowTS;
		    		dss.ajaxAssyncRequestWithoutAnswer('/json/device/getSensorValue', {
		    			dsuid : sensordSID,
		    			sensorIndex : iIndex
		    		}, function(answer) {
		    			result=Ext.JSON.decode(answer);	    		
		    			var orgValue=(result.result.sensorValue/40)-43.15;
						me.lastSensorValue=orgValue;
		    			me.editControls.temperature.setValue(orgValue);
		    			me.editControls.temperature.originalValue=(orgValue);
		    		});
				} else {
	    			me.editControls.temperature.setValue(me.lastSensorValue);
	    			me.editControls.temperature.originalValue=(me.lastSensorValue);
				}
			}
		}		
    },
    fillControls: function () {
		var record=Ext.data.StoreManager.lookup('generalSetting').findRecord('dsid',this.dsid,0,true,false,true);
    	if (record!=null) {
    		this.editControls.nameEditor.setValue(dss.staticDataModel.getDevice(this.dsid).name);
    		this.editControls.nameEditor.originalValue=(dss.staticDataModel.getDevice(this.dsid).name);
    		var oValue=record.get('values');
    		for (var sKey in this.editControls) {
    			if (this.editControls[sKey].deviceConfigValues!= null) {
    				var editDeviceIndex=this.editControls[sKey].deviceConfigValues.deviceIndex
    				var editBank=this.editControls[sKey].deviceConfigValues.bank;
    				var editIndex=this.editControls[sKey].deviceConfigValues.parameter;
    				
    				for (var iIndex=0;iIndex<oValue.length;iIndex++) {
    					if (oValue[iIndex].deviceIndex==editDeviceIndex)
        					if (oValue[iIndex].bank==editBank)
            					if (oValue[iIndex].index==editIndex) {
            						var value=oValue[iIndex].value; 
            						if (this.editControls[sKey].deviceConfigValues.bitmask!=null)
            							value=(this.editControls[sKey].deviceConfigValues.bitmask & value)?true:false;
            						if (this.editControls[sKey].valueName!=null) {
            							var oObject={};
            							oObject[this.editControls[sKey].valueName]=value;
            							this.editControls[sKey].setValue(oObject);
            						} else
            							this.editControls[sKey].setValue(value);
            					}
    				}
    				
    			}
    		}    		
    		this.fillTemperatureControl();
    	} else {
    		this.editControls.lblRoom.setValue('');
    	}
    	
    },
    constructGeneralSetting:function() {
    	var me=this;
    	this.editControls.nameEditor=Ext.create('Ext.form.field.Text',{
			fieldLabel:_('Device name'),
			width:500
		});
    	var lbl = Ext.create('Ext.form.field.Display',{
            width:560			
		}); 
    	lbl.setValue(_('To set a temperature offset, please enter the current valid temperature'));
    	                                
	    var resetButton= Ext.create('Ext.Button', {
              text : _('Reset to factory default'),              
              handler : function() {
                  Ext.Msg.confirm(_('Please confirm'),_('Thanos device will be reset to factory default. This will take a while.'),function (btn) {
                	  if (btn=='yes') {
                		  dss.raiseEvent('thanos.config',{actions:'resetToDefault',dsid:me.dsid});
                		  me.hide();
                	  }                		  
                  } ); 
              }
          });
    	
	    var refreshButton= Ext.create('Ext.Button', {
            text : _('Start fresh readout'),              
            handler : function() {
				dss.raiseEvent('thanos.config',{actions:'fetchAllScreens',dsid:me.dsid,forced:true});
				me.hide();
            }              
        });
  	
	    
    	//Temperatur Offset [1/10 K)
    	//Humidity Offset [1/10 K)
    	var me=this;
    	this.editControls.temperature= Ext.create('Ext.form.field.Number', {
            name : 'temperature',
            allowBlank : false,
            blankText : _('This field is required'),
            invalidText : _('The value in this field is invalid'),
            fieldLabel : _('Current temperature'),
            width : 270,
            step : 0.1,
            value : 0,
            minValue : 0,
            maxValue : 100,
            labelWidth:200,
            decimalPrecision:1,
            decimalSeperator:','
        });
    	this.editControls.temperature.isDirty=function() {
    		var orgValue=Math.floor(me.editControls.temperature.originalValue*40+0.5);
    		var newValue=Math.floor(me.editControls.temperature.getValue()*40+0.5);
    		return (orgValue!=newValue);
    	}
    	var calibrateTemperatureButton= Ext.create('Ext.Button', {
            text : _('Reset temperature offset'),
            margin: '0 0 0 5',
            
            handler : function() {
               if (me.editControls.temperature.getValue()!=0) {
            	   dss.raiseEvent('thanos.config',{
            		   actions:'resetTemperatureSensor',
            		   dsid:me.dsid            		   
            	   });
            	   me.sensordsid="";
            	   me.sensorts=0;
               }
            }
        });
    	var gradc=Ext.create('Ext.panel.Panel', {
			padding : '2 0 0 5',
			border : false,
			html : '<span style="color:#005138">&deg;C</span>',
			flex:1
		});
    	
    	var subPanel=Ext.create('Ext.panel.Panel',{
    		border:false,
    		layout: 'hbox',
    		width:550,
    		items:[this.editControls.temperature,gradc,calibrateTemperatureButton]
    	});
    		
    	var itemsArray= [{
			xtype:'panel',
			flex:1,
			border:0
		}];
    	if (expertMode) {
    		itemsArray.push(resetButton);
    		itemsArray.push(refreshButton);
    	}
    	
    	return Ext.create('Ext.panel.Panel',{
    		padding:'5 5 5 5',
    		title:_('Advanced Settings'),
    		layout:'vbox',
    		items:[lbl,subPanel,{
    			xtype:'panel',
    			flex:1,
    			border:0
    		},{
        		width:550,
    			xtype:'panel',
    			items: itemsArray,
        		layout:'hbox',
    			border:0
    		}]
    	});

    },
    constructDisplaySetting:function() {

    	this.editControls.displayBackColor =Ext.create('Ext.form.RadioGroup', {
            columns: 2,            
            fieldLabel :_('Display color'),
            vertical:true,
            items: [
                    {boxLabel:_('white'),name:'displayBackColor',inputValue:false},
                    {boxLabel:_('black'),name:'displayBackColor',inputValue:true}
            ],
            width:275,
            style:{color:'#005138'}
        });
    	this.editControls.displayBackColor.valueName='displayBackColor';
    	this.editControls.displayBackColor.deviceConfigValues={
    			deviceIndex:0,
    			bank:127,
    			parameter:50,
    			bitmask:0x01
    	};

    	this.editControls.displayAutoOff =Ext.create('Ext.form.field.Checkbox', {
            name : 'displayAutoOff',
            boxLabel :_('Turn screen off automatically'),
            allowBlank : false,
            style:{color:'#005138'}
        });
    	this.editControls.displayAutoOff.deviceConfigValues={
    			deviceIndex:0,
    			bank:127,
    			parameter:50,
    			bitmask:0x02
    	};    	
    	
    	this.editControls.favoriteActive =Ext.create('Ext.form.field.Checkbox', {
            name : 'favoriteActive',
            boxLabel:_('Show favorite screen'),
            allowBlank : false,
            style:{color:'#005138'}
        });
    	this.editControls.favoriteActive.deviceConfigValues={
    			deviceIndex:0,
    			bank:127,
    			parameter:50,
    			bitmask:0x04
    	};    	
    	this.editControls.absentActive =Ext.create('Ext.form.field.Checkbox', {
            name : 'absentActive',
            boxLabel :_("Show 'Leave home' icon"),
            allowBlank : false,
            style:{color:'#005138'}
        });
    	this.editControls.absentActive.deviceConfigValues={
    			deviceIndex:0,
    			bank:127,
    			parameter:50,
    			bitmask:0x08
    	};    	

    	this.editControls.outsideTemperatureActive =Ext.create('Ext.form.field.Checkbox', {
            name : 'outsideTemperatureActive',
            boxLabel :_('Show outside temperature'),
            allowBlank : false,
            style:{color:'#005138'}
        });
    	this.editControls.outsideTemperatureActive.deviceConfigValues={
    			deviceIndex:0,
    			bank:127,
    			parameter:51,
    			bitmask:0x04
    	}; 
    	 	
    	this.editControls.peepOnClick =Ext.create('Ext.form.field.Checkbox', {
            name : 'peepOnClick',
            boxLabel :_("Play sound when clicking buttons or 'spange'"),
            allowBlank : false,
            style:{color:'#005138'}
        });
    	this.editControls.peepOnClick.deviceConfigValues={
    			deviceIndex:0,
    			bank:127,
    			parameter:60,
    			bitmask:0x02
    	};    	
    	
    	this.editControls.spangeForLight =Ext.create('Ext.form.field.Checkbox', {
            name : 'spangeForLight',
            boxLabel :_("Use the 'spange' as light switch within the room"),
            allowBlank : false,
            style:{color:'#005138'}
        });
    	this.editControls.spangeForLight.deviceConfigValues={
    			deviceIndex:0,
    			bank:127,
    			parameter:52,
    			bitmask:0x07
    	};    	
    	
    	this.editControls.brightness= Ext.create('Ext.form.field.Number', {
            name : 'brightness',
            allowBlank : false,
            blankText : _('This field is required'),
            invalidText : _('The value in this field is invalid'),
            fieldLabel : _('Screen brightness'),
            width : 270,
            step : 1,
            value : 0,
            margin: '0 0 5 0',
            minValue : 0,
            maxValue : 100,
            labelWidth:220,
            decimalPrecision:0
        });
    	this.editControls.brightness.deviceConfigValues={
    			deviceIndex:0,
    			bank:127,
    			parameter:55
    	};    	
    	this.editControls.brightnessDimmed= Ext.create('Ext.form.field.Number', {
            name : 'brightnessDimmed',
            allowBlank : false,
            blankText : _('This field is required'),
            invalidText : _('The value in this field is invalid'),
            fieldLabel : _('Screen brightness dimmed'),
            width : 270,
            step : 1,
            value : 0,
            margin: '0 0 5 0',
            minValue : 0,
            maxValue : 100,
            labelWidth:220,
            decimalPrecision:0
        });
    	this.editControls.brightnessDimmed.deviceConfigValues={
    			deviceIndex:0,
    			bank:127,
    			parameter:57
    	};    	
    	this.editControls.delayTurnOff= Ext.create('Ext.form.field.Number', {
            name : 'delayTurnOff',
            allowBlank : false,
            blankText : _('This field is required'),
            invalidText : _('The value in this field is invalid'),
            fieldLabel : _('Turn off display after'),
            margin: '0 0 5 0',
            width : 270,
            step : 1,
            value : 0,
            minValue : 0,
            maxValue : 255,
            labelWidth:220,
            decimalPrecision:0
        });
    	this.editControls.delayTurnOff.deviceConfigValues={
    			deviceIndex:0,
    			bank:127,
    			parameter:58
    	};    	
    	this.editControls.delayTurnOffDimmed= Ext.create('Ext.form.field.Number', {
            name : 'delayTurnOffDimmed',
            allowBlank : false,
            blankText : _('This field is required'),
            invalidText : _('The value in this field is invalid'),
            fieldLabel : _('Dimm display after'),
            margin: '0 0 5 0',
            width : 270,
            step : 1,
            value : 0,
            minValue : 0,
            maxValue : 255,
            labelWidth:220,
            decimalPrecision:0
        });
    	this.editControls.delayTurnOffDimmed.deviceConfigValues={
    			deviceIndex:0,
    			bank:127,
    			parameter:56
    	};    	
    	var returnPanel=Ext.create('Ext.panel.Panel',{
    		layout:{
    			type:'table',
    			columns:1
    		},
    		overflowY:"auto",
    		padding:'5 5 5 5',
    		width:560,
    		title:_('Display'),
    		items:[this.editControls.displayBackColor,
    		       this.editControls.favoriteActive,this.editControls.absentActive,
    		       this.editControls.outsideTemperatureActive,
    		       this.editControls.peepOnClick,this.editControls.spangeForLight,
    		       this.editControls.displayAutoOff,
    		       {
   						xtype:'panel',
   						border:0,
   						width:500,
   						layout:'hbox',
   						items: [this.editControls.brightness,
   					        { xtype:'panel',
   					    	  padding : '2 0 0 5',
   					    	  border : false,
   					    	  html : '<span style="color:#005138">%</span>'}]
    		       },{
      					xtype:'panel',
       					border:0,
       					layout:'hbox',
   						width:500,
       					items: [this.editControls.delayTurnOffDimmed,
       					        { xtype:'panel',
       					    	  padding : '2 0 0 5',
       					    	  border : false,
       					    	  html : '<span style="color:#005138">s</span>'}]
        		   },{
        			   xtype:'panel',
        			   border:0,
        			   layout:'hbox',
  						width:500,
        			   items: [this.editControls.brightnessDimmed,
					      {   xtype:'panel',
					    	  padding : '2 0 0 5',
					    	  border : false,
					    	  html : '<span style="color:#005138">%</span>'}]
    		       },{
      					xtype:'panel',
       					border:0,
       					layout:'hbox',
   						width:500,
       					items: [this.editControls.delayTurnOff,
       					        { xtype:'panel',
       					    	  padding : '2 0 0 5',
       					    	  border : false,
       					    	  html : '<span style="color:#005138">s</span>'}]
        		   }]
    	});

    	if (expertMode) {
            this.editControls.visualisationActive =Ext.create('Ext.form.field.Checkbox', {
                name : 'visualisationActive',
                boxLabel :_('Show current room status (test only)'),
                allowBlank : false,
                style:{color:'#005138'}
            });
            this.editControls.visualisationActive.deviceConfigValues={
                    deviceIndex:0,
                    bank:127,
                    parameter:50,
                    bitmask:0x80
            };
            returnPanel.add(this.editControls.visualisationActive);
            
        	this.editControls.targetTemperatureActive =Ext.create('Ext.form.field.Checkbox', {
                name : 'targetTemperatureActive',
                boxLabel :_('Targettemperature visible'),
                allowBlank : false,
                style:{color:'#005138'}
            });
        	this.editControls.targetTemperatureActive.deviceConfigValues={
        			deviceIndex:0,
        			bank:127,
        			parameter:50,
        			bitmask:0x40
        	}; 
        	returnPanel.add(this.editControls.targetTemperatureActive);

        	this.editControls.roomNotUsedActive =Ext.create('Ext.form.field.Checkbox', {
                name : 'roomNotUsedActive',
                boxLabel :_('Heating Not-Used button active'),
                allowBlank : false
            });
        	this.editControls.roomNotUsedActive.deviceConfigValues={
        			deviceIndex:0,
        			bank:127,
        			parameter:50,
        			bitmask:0x10
        	};    	
        	returnPanel.add(this.editControls.roomNotUsedActive);
        	this.editControls.humindityActive =Ext.create('Ext.form.field.Checkbox', {
                name : 'humindityActive',
                boxLabel :_('Humidity visible'),
                allowBlank : false
            });
        	this.editControls.humindityActive.deviceConfigValues={
        			deviceIndex:0,
        			bank:127,
        			parameter:50,
        			bitmask:0x20
        	};    	
        	returnPanel.add(this.editControls.humindityActive);
        	this.editControls.wakeUpSignal =Ext.create('Ext.form.field.Checkbox', {
                name : 'wakeUpSignal',
                boxLabel :_('Wake up on Alarm/Panic/Fire/Bell'),
                allowBlank : false
            });
        	this.editControls.wakeUpSignal.deviceConfigValues={
        			deviceIndex:0,
        			bank:127,
        			parameter:51,
        			bitmask:0x01
        	};    	
        	returnPanel.add(this.editControls.wakeUpSignal);
        	this.editControls.wakeUpWeather =Ext.create('Ext.form.field.Checkbox', {
                name : 'wakeUpWeather',
                boxLabel :_('Wake upon Wind/Hail/Rain'),
                allowBlank : false
            });
        	this.editControls.wakeUpWeather.deviceConfigValues={
        			deviceIndex:0,
        			bank:127,
        			parameter:51,
        			bitmask:0x02
        	};   
        	returnPanel.add(this.editControls.wakeUpWeather);
        	this.editControls.brightnessOff= Ext.create('Ext.form.field.Number', {
                name : 'brightnessOff',
                allowBlank : false,
                blankText : _('This field is required'),
                invalidText : _('The value in this field is invalid'),
                fieldLabel : _('Brightness display off'),
                width : 270,
                step : 1,
                value : 0,
                minValue : 0,
                maxValue : 100,
                labelWidth:200,
                decimalPrecision:0
            });
        	this.editControls.brightnessOff.deviceConfigValues={
        			deviceIndex:0,
        			bank:127,
        			parameter:59
        	};    	
        	returnPanel.add(this.editControls.brightnessOff);
    	}
    	
    	return returnPanel;
    },    
    constructSignalSetting:function() {
    	/*Feedback Touch 
		Signalize Fire
		Signalize Panic
	*/
    	var lbl = Ext.create('Ext.form.field.Display',{
			fieldLabel: '',
            width:560			
		}); 
    	lbl.setValue( _('Please select which security alerts should be announced'));
    	
    	this.editControls.fireSignal=Ext.create('DSS.component.Signal', {
    		id:'fire',
    		fieldlabel:_('fire alarm')
    	});
    	this.editControls.fireSignal.deviceConfigValues={
    			deviceIndex:0,
    			bank:127,
    			parameter:64
    	};    	
    	
    	this.editControls.panicSignal=Ext.create('DSS.component.Signal', {
    		id:'panic',
    		fieldlabel:_('panic')
    	});
    	this.editControls.panicSignal.deviceConfigValues={
    			deviceIndex:0,
    			bank:127,
    			parameter:68
    	};    	
 	
    	return Ext.create('Ext.panel.Panel',{
    		title:_('Security'),
    		padding:'5 5 5 5',
    		width:560,
    		layout: 'vbox',
    		items:[lbl,this.editControls.fireSignal,this.editControls.panicSignal]
    	});

    },
    constructSignalAlarmSetting:function() {
    	/*		Signalize Alarm 1
		Signalize Alarm 2
		Signalize Alarm 3
		Signalize Alarm 4
		
	*/
    	var lbl = Ext.create('Ext.form.field.Display',{
            width:560			
		}); 
    	lbl.setValue(_('Please select which alarms should be announced'));
    	
    	this.editControls.alarm1Signal=Ext.create('DSS.component.Signal', {
    		id:'alarm1',
    		fieldlabel:_('alarm 1')
    	});
    	this.editControls.alarm1Signal.deviceConfigValues={
    			deviceIndex:0,
    			bank:127,
    			parameter:72
    	};    	
    	this.editControls.alarm2Signal=Ext.create('DSS.component.Signal', {
    		id:'alarm2',
    		fieldlabel:_('alarm 2')
    	});
    	this.editControls.alarm2Signal.deviceConfigValues={
    			deviceIndex:0,
    			bank:127,
    			parameter:76
    	};    	
    	this.editControls.alarm3Signal=Ext.create('DSS.component.Signal', {
    		id:'alarm3',
    		fieldlabel:_('alarm 3')
    	});
    	this.editControls.alarm3Signal.deviceConfigValues={
    			deviceIndex:0,
    			bank:127,
    			parameter:80
    	};    	
    	this.editControls.alarm4Signal=Ext.create('DSS.component.Signal', {
    		id:'alarm4',
    		fieldlabel:_('alarm 4')
    	});
    	this.editControls.alarm4Signal.deviceConfigValues={
    			deviceIndex:0,
    			bank:127,
    			parameter:84
    	};    	

    	
    	return Ext.create('Ext.panel.Panel',{
    		title:_('Signal - Alarm'),
    		padding:'5 5 5 5',
    		width:560,
    		layout: 'vbox',
    		items:[lbl,this.editControls.alarm1Signal,this.editControls.alarm2Signal,this.editControls.alarm3Signal,this.editControls.alarm4Signal]
    	});

    },
    constructSignalBellSetting:function() {
    	/*Signalize Bell 1
		Signalize Bell 2
		Signalize Bell 3
		Signalize Bell 4
	*/
    	var lbl = Ext.create('Ext.form.field.Display',{
            width:560			
		});
    	lbl.setValue(_('Please select how the door bell should be announced'));
    	
    	this.editControls.doorBell=Ext.create('DSS.component.Signal', {
    		id:'bell1',
    		fieldlabel:_('Door bell')
    	});
    	this.editControls.doorBell.deviceConfigValues={
    			deviceIndex:0,
    			bank:127,
    			parameter:88
    	}; 
        var returnValue=Ext.create('Ext.panel.Panel',{
    		title:_('Door bell'),
    		padding:'5 5 5 5',
    		width:560,
    		layout: 'vbox',
    		items:[lbl,this.editControls.doorBell]
    	});

        
        if (expertMode) {
                
        	this.editControls.doorBell2=Ext.create('DSS.component.Signal', {
        		id:'bell2',
        		fieldlabel:_('Door bell 2')
        	});
        	this.editControls.doorBell2.deviceConfigValues={
        			deviceIndex:0,
        			bank:127,
        			parameter:92
        	}; 
        	this.editControls.doorBell3=Ext.create('DSS.component.Signal', {
        		id:'bell3',
        		fieldlabel:_('Door bell 3')
        	});
        	this.editControls.doorBell3.deviceConfigValues={
        			deviceIndex:0,
        			bank:127,
        			parameter:96
        	}; 
        	this.editControls.doorBell4=Ext.create('DSS.component.Signal', {
        		id:'bell4',
        		fieldlabel:_('Door bell 4')
        	});
        	this.editControls.doorBell4.deviceConfigValues={
        			deviceIndex:0,
        			bank:127,
        			parameter:100
        	}; 
        	returnValue.add(this.editControls.doorBell2);
        	returnValue.add(this.editControls.doorBell3);
        	returnValue.add(this.editControls.doorBell4);
        }
    		
    	return returnValue; 

    },
    baseGrid:null,
    constructor : function(config) {
    	
    	config.closeAction = 'hide';
        config.modal = true; 
        config.resizable=false;
        var sCancelText=_('cancel');
        var sSaveText=_('save');
        var me=this;
        var entries={};
        var oSubItems=[];
        oSubItems.push(this.constructDisplaySetting());
        oSubItems.push(this.constructSignalSetting());
        oSubItems.push(this.constructSignalAlarmSetting());
        oSubItems.push(this.constructSignalBellSetting());
        oSubItems.push(this.constructGeneralSetting());

    	this.editControls.nameEditor=Ext.create('Ext.form.field.Text',{
			fieldLabel:_('Device name'),
			width:500
		});
        
        this.settingPanel= Ext.create('Ext.tab.Panel', {
            items:oSubItems,
            width:565,
            height:425
        });
        
        this.displayBottomText=Ext.create('Ext.form.field.Display', {
            border : 0,
            value:'',
            style: {
                fontSize: '11px'
            },
            padding:'0 0 2 5',
            flex:1
        });        
        this.buttonCancel = Ext.create('Ext.Button', {
            text : sCancelText,
            handler : function() {
                me.hide();
            }
        });
        this.buttonSave = Ext.create('Ext.Button', {
            text : sSaveText,
            handler : function() {
            	me.saveValues();
				me.baseWindow.fShouldWork=true;
				me.baseWindow.progress.setVisible(true);
				me.baseWindow.progress.maximunStep=0;
				me.baseWindow.grid.setStatus(_('Preparing data'));

            	
            	me.hide();
            }
        });

        var oButtons=[this.displayBottomText,this.buttonSave,this.buttonCancel];
        
        
        Ext.apply(this, {
        	title:_('General settings'),
        	height:535,
        	width:600,
        	listeners: {
        		show: function () {
        			me.initStores();
        			me.fillControls();
        		}
        	},
            items : [ {
            	padding: '5 5 5 5',
            	xtype : 'panel',
                layout : 'vbox',
                items : [this.editControls.nameEditor,this.settingPanel],
                bodyPadding : 5,
                border : 0,
                height: 505,
                
                dockedItems: [{
                    xtype: 'toolbar',
                    dock: 'bottom',
                    ui: 'footer',
                    defaults: {minWidth: 75},
                    items: oButtons
                }]
            } ]
        }); // Ext.apply
        this.callParent(arguments);
    }
});