Ext.define('DSS.addon.ThanosSimulator', {
	extend : 'DSS.component.Base',
	height : 573,
	width:407,
	basePanel:null,
	buttons:{},
	defaultButton:function (type) {
		switch (type) {
			case 1:
				return '001';
				break;
			case 2:
				return '010';
				break;
			case 3:
				return '061';
				break;
			case 4:
				return '141';
				break;
			case 5:
				return '031';
				break;
			case 8:
				return '051';
				break;
			case 9:
				return '081';
				break;
			case 10:
				return '041';
				break;
			case 48:
				return '';
				break;
		} 
		return "";
	},
	setFavorite: function (favoriteSetting) {
		
		this.colorBar.setBodyStyle('background-color: transparent; background-image: url(images/thanos/200.bmp); background-repeat: no-repeat;');
		this.middle.getEl().setHTML('<table style="width:100%;height:100%;"><tr><td style="padding:5 0 0 0;"><img style="padding-left:60px;" src="images/thanos/125.bmp"></td></tr></table>');
		
		var icons={
			1:'',
			2:'',
			3:'',
			4:'',
			5:'',
			6:'',
			7:'',
			8:'',
			9:'',
			10:'',
			11:''
		};
		
		icons['1']=this.defaultButton(favoriteSetting['0'].type);
		icons['4']=this.defaultButton(favoriteSetting['1'].type);
		icons['5']=this.defaultButton(favoriteSetting['2'].type);
		icons['6']=this.defaultButton(favoriteSetting['3'].type);
		icons['7']=this.defaultButton(favoriteSetting['4'].type);
		icons['8']=this.defaultButton(favoriteSetting['5'].type);
		icons['9']=this.defaultButton(favoriteSetting['6'].type);
		this.setIcon(icons);
		
		if (favoriteSetting['0'].type==0)
			this.button1Text.setText('');
		else
			this.button1Text.setText(favoriteSetting['0'].name);
		
		if (favoriteSetting['1'].type==0)
			this.button4Text.setText('');
		else
			this.button4Text.setText(favoriteSetting['1'].name);
		
		if (favoriteSetting['2'].type==0)
			this.button5Text.setText('');
		else
			this.button5Text.setText(favoriteSetting['2'].name);
		
		if (favoriteSetting['3'].type==0)
			this.button6Text.setText('');
		else
			this.button6Text.setText(favoriteSetting['3'].name);
		
		if (favoriteSetting['4'].type==0)
			this.button7Text.setText('');
		else
			this.button7Text.setText(favoriteSetting['4'].name);
		
		if (favoriteSetting['5'].type==0)
			this.button8Text.setText('');
		else
			this.button8Text.setText(favoriteSetting['5'].name);
		
		if (favoriteSetting['6'].type==0)
			this.button9Text.setText('');
		else
			this.button9Text.setText(favoriteSetting['6'].name);
		this.buttons['12'].setBodyStyle('background-color: transparent; background-image: url(images/thanos/101.bmp); background-repeat: no-repeat;');

	},
	setType : function (type,names) {
//		this.middleText.setText('');
		this.middle.getEl().setHTML('');
		this.button4Text.setText("");
		this.button6Text.setText("");
		this.button8Text.setText("");

		if (names.scene1!=null)
			this.button1Text.setText(names.scene1);
		else
			this.button1Text.setText('');
		
		if (names.scene2!=null)
			this.button5Text.setText(names.scene2);
		else
			this.button5Text.setText('');
		
		if (names.scene3!=null)
			this.button7Text.setText(names.scene3);
		else
			this.button7Text.setText('');
		
		if (names.scene4!=null)
			this.button9Text.setText(names.scene4);
		else
			this.button9Text.setText('');
		
		switch (type) {
			case 1: {
				this.colorBar.setBodyStyle('background-color: transparent; background-image: url(images/thanos/201.bmp); background-repeat: no-repeat;');
				this.setIcon({1:'001',
					2:'',
					3:'002',
					4:'003',
					5:'001',
					6:'150',
					7:'001',
					8:'151',
					9:'001',
					10:'',
					11:'105'
					});
				this.middle.getEl().setHTML('<table style="width:100%;height:100%;"><tr><td style="padding:5 0 0 0;"><img style="padding-left:60px;" src="images/thanos/005.bmp"></td></tr></table>')
//				this.middle.setBodyStyle('background-color: transparent; background-image: url(images/thanos/005.bmp); background-repeat: no-repeat;background-position: 40px 40px;');
				
				break;
			}
			case 2: {
				this.colorBar.setBodyStyle('background-color: transparent; background-image: url(images/thanos/202.bmp); background-repeat: no-repeat;');				
				this.setIcon({1:'010',
					2:'',
					3:'014',
					4:'013',
					5:'011',
					6:'152',
					7:'011',
					8:'153',
					9:'011',
					10:'',
					11:'161'
					});
				this.middle.getEl().setHTML('<table style="width:100%;height:100%;"><tr><td style="padding:5 0 0 0;"><img style="padding-left:60px;" src="images/thanos/016.bmp"></td></tr></table>')
				break;
			}
			case 3: {
				this.colorBar.setBodyStyle('background-color: transparent; background-image: url(images/thanos/203.bmp); background-repeat: no-repeat;');				
				this.setIcon({1:'061',
					2:'',
					3:'',
					4:'062',
					5:'061',
					6:'152',
					7:'061',
					8:'153',
					9:'061',
					10:'',
					11:''
					});
				this.middle.getEl().setHTML('<table style="width:100%;height:100%;"><tr><td style="padding:5 0 0 0;"><img style="padding-left:60px;" src="images/thanos/066.bmp"></td></tr></table>')
				break;
			}
			case 4: {
				this.colorBar.setBodyStyle('background-color: transparent; background-image: url(images/thanos/204.bmp); background-repeat: no-repeat;');				
				this.setIcon({1:'141',
					2:'',
					3:'',
					4:'162',
					5:'024',
					6:'154',
					7:'024',
					8:'156',
					9:'024',
					10:'',
					11:''
					});
				this.middle.getEl().setHTML('<table style="width:100%;height:100%;"><tr><td style="padding:5 0 0 0;"><img style="padding-left:60px;" src="images/thanos/027.bmp"></td></tr></table>')
				break;
			}
			case 5: {
				this.colorBar.setBodyStyle('background-color: transparent; background-image: url(images/thanos/205.bmp); background-repeat: no-repeat;');				
				this.setIcon({1:'031',
					2:'',
					3:'',
					4:'032',
					5:'031',
					6:'152',
					7:'031',
					8:'153',
					9:'031',
					10:'',
					11:''
					});
				this.middle.getEl().setHTML('<table style="width:100%;height:100%;"><tr><td style="padding:5 0 0 0;"><img style="padding-left:60px;" src="images/thanos/036.bmp"></td></tr></table>')
				break;
			}
			case 8: {
				this.colorBar.setBodyStyle('background-color: transparent; background-image: url(images/thanos/208.bmp); background-repeat: no-repeat;');				
				this.setIcon({1:'051',
					2:'',
					3:'',
					4:'',
					5:'051',
					6:'',
					7:'051',
					8:'',
					9:'051',
					10:'',
					11:''
					});
				this.middle.getEl().setHTML('<table style="width:100%;height:100%;"><tr><td style="padding:5 0 0 0;"><img style="padding-left:60px;" src="images/thanos/055.bmp"></td></tr></table>')
				break;
			}
			case 9: {
				this.colorBar.setBodyStyle('background-color: transparent; background-image: url(images/thanos/203.bmp); background-repeat: no-repeat;');				
				this.setIcon({1:'081',
					2:'',
					3:'',
					4:'082',
					5:'081',
					6:'152',
					7:'081',
					8:'153',
					9:'081',
					10:'',
					11:''
					});
				this.middle.getEl().setHTML('<table style="width:100%;height:100%;"><tr><td style="padding:5 0 0 0;"><img style="padding-left:60px;" src="images/thanos/085.bmp"></td></tr></table>')
				break;
			}
			case 10: {
				this.colorBar.setBodyStyle('background-color: transparent; background-image: url(images/thanos/203.bmp); background-repeat: no-repeat;');				
				this.setIcon({1:'041',
					2:'',
					3:'',
					4:'042',
					5:'041',
					6:'144',
					7:'041',
					8:'146',
					9:'041',
					10:'',
					11:''
					});
				this.middle.getEl().setHTML('<table style="width:100%;height:100%;"><tr><td style="padding:5 0 0 0;"><img style="padding-left:60px;" src="images/thanos/046.bmp"></td></tr></table>')
				break;
			}
			case 48: {
				this.colorBar.setBodyStyle('background-color: transparent; background-image: url(images/thanos/203.bmp); background-repeat: no-repeat;');				
				this.setIcon({1:'247',
					2:'',
					3:'',
					4:'248',
					5:'',
					6:'152',
					7:'',
					8:'153',
					9:'',
					10:'',
					11:''
					});
				this.button1Text.setText('');				
				this.button5Text.setText('');
				this.button7Text.setText('');
				this.button9Text.setText('');
				this.middle.getEl().setHTML('<table style="width:100%;height:100%;">'+
						'<tr><td colspan="2" style="padding:8px 0px 0px 0px;"><table>'+
						     '<tr><td rowspan="2" style="width:100%;text-align:right;font-size:34px;">22</td><td style="width:10px;">&deg;C</td><td rowspan="2"><img style="margin-left: 8px;" src="images/thanos/251.bmp"></td></tr>'+
						     '<tr><td style="font-size:12px;">,0</td></tr></table></td></tr>'+
						'<tr><td rowspan="2" style="text-align: right; font-size: 60px; padding: 0px;">21</td><td style="font-size: 15px; padding-left: 3px; padding-top: 9px; padding-bottom: 0px;">&deg;C</td></tr>'+
						'<tr><td style="font-size: 20px; padding-top: 0px; padding-left: 0px;">,5</td></tr>'+
						'<tr><td colspan="2" style="text-align: right; font-size: 20px; padding-top: 5px;">45%</td></tr>'+
						'<tr><td colspan="2" style="height:100%;width:100%;"></td></tr></table>');
				break;
			}
		}
	},
	setIcon : function (iconObject) {
		for (var sKey in iconObject) {
			if (iconObject[sKey]!='')
				this.buttons[sKey].setBodyStyle('background-color: transparent; background-image: url(images/thanos/'+iconObject[sKey]+'.bmp); background-repeat: no-repeat;');
			else
				this.buttons[sKey].setBodyStyle('background-color: transparent; background-image: url(/framework/images/t.gif); background-repeat: no-repeat;');
		}	
		this.buttons['12'].setBodyStyle('background-color: transparent; background-image: url(images/thanos/100.bmp); background-repeat: no-repeat;');
	},
	constructor : function(config) {
		config.width=512;
		config.height=722;
		config.bodyCls='thanosBase';
		var me = this;
		this.button1Text=Ext.create('Ext.form.Label',{
			margin: '65 0 0 89'
		});
		this.button5Text=Ext.create('Ext.form.Label',{
			margin: '150 0 0 89'
		});
		this.button7Text=Ext.create('Ext.form.Label',{
			margin: '240 0 0 89'
		});
		this.button9Text=Ext.create('Ext.form.Label',{
			margin: '325 0 0 89'
		});
		/*this.middleText=Ext.create('Ext.form.Label',{
			style: 'text-align:middle;font-size:34px;'
		});*/
		this.button4Text=Ext.create('Ext.form.Label',{
			margin: '65 0 0 240',
			width:84,
			style: 'text-align:right'
		});
		this.button6Text=Ext.create('Ext.form.Label',{
			margin: '150 0 0 240',
			width:84,
			style: 'text-align:right'
		});
		this.button8Text=Ext.create('Ext.form.Label',{
			margin: '240 0 0 240',
			width:84,
			style: 'text-align:right'
		});
		
		this.colorBar= Ext.create('Ext.panel.Panel', {
		    width:5,
		    height:320,
		    rowspan:4,
		    margin: '66 0 0 82',
		    border: 0
		});
		this.buttons['1']= Ext.create('Ext.panel.Panel', {
		    width:40,
		    height:40,
		    margin: '79 0 0 88',
		    border: 0
		});
		this.buttons['2']= Ext.create('Ext.panel.Panel', {
		    width:40,
		    height:40,
		    margin: '79 16 0 20',
		    border: 0
		});
		this.buttons['3']= Ext.create('Ext.panel.Panel', {
		    width:56,
		    height:40,
		    margin: '79 0 0 20',
		    border: 0
		});
		this.buttons['4']= Ext.create('Ext.panel.Panel', {
		    width:40,
		    height:40,
		    margin: '79 0 0 0',
		    border: 0
		});
		this.buttons['5']= Ext.create('Ext.panel.Panel', {
		    width:40,
		    height:40,
		    margin: '40 0 0 88',
		    border: 0		    
		});
		this.buttons['6']= Ext.create('Ext.panel.Panel', {
		    width:40,
		    height:40,
		    margin: '40 0 0 0',
		    border: 0			    
		});
		this.buttons['7']= Ext.create('Ext.panel.Panel', {
		    width:40,
		    height:40,
		    margin: '40 0 0 88',
		    border: 0
		});
		this.buttons['8']= Ext.create('Ext.panel.Panel', {
		    width:40,
		    height:40,
		    margin: '40 0 0 0',
		    border: 0		    
		});
		this.buttons['9']= Ext.create('Ext.panel.Panel', {
		    width:40,
		    height:40,
		    margin: '40 0 0 88',
		    border: 0
		});
		this.buttons['10']= Ext.create('Ext.panel.Panel', {
		    width:40,
		    height:40,
		    margin: '40 20 0 20',
		    border: 0
		});
		this.buttons['11']= Ext.create('Ext.panel.Panel', {
		    width:56,
		    height:40,
		    margin: '40 0 0 16',
		    border: 0
		});
		this.buttons['12']= Ext.create('Ext.panel.Panel', {
		    width:40,
		    height:40,
		    margin: '40 0 0 0',
		    border:0,
		    bodyStyle:'background-color: transparent; background-image: url(images/thanos/100.bmp); background-repeat: no-repeat;'
		});

		
		this.middle= Ext.create('Ext.panel.Panel', {
		    width:136,
		    height:180,
		    rowspan:2,
		    colspan:2,
		    margin: '0 0 0 20',
		    border: 0,
		    style:'padding-top:5px;',
		    
		    items:[this.middleText]
		});
		
		this.setIcon({1:'',
			2:'',
			3:'',
			4:'',
			5:'',
			6:'',
			7:'',
			8:'',
			9:'',
			10:'',
			11:''
			});
		this.basePanel= Ext.create('Ext.panel.Panel', {
			bodyStyle:'background-color: transparent; background-image: url(images/thanos/base.png); background-repeat: no-repeat;',
		    width:407,
		    height:573,
		    border:false,
		    layout:{
		    	type:'table',
		    	columns:4
		    },
			items:[this.buttons['1'],this.buttons['2'],this.buttons['3'],this.buttons['4'],
			       this.buttons['5'],this.middle,this.buttons['6'],this.buttons['7'],this.buttons['8'],
			       this.buttons['9'],this.buttons['10'],this.buttons['11'],this.buttons['12']]
		});
		
		Ext.apply(this, {
			layout: {
				type:'absolute'
			},
		    items:[this.basePanel,this.colorBar,this.button1Text,this.button5Text,this.button7Text,this.button9Text,this.button4Text,this.button6Text,this.button8Text]
		});
	
		this.callParent(arguments);
	},
	resetSimulator: function () {
		this.button1Text.setText('');				
		this.button5Text.setText('');
		this.button7Text.setText('');
		this.button9Text.setText('');
		this.button4Text.setText('');
		this.button6Text.setText('');
		this.button8Text.setText('');
		this.setIcon({1:'',
			2:'',
			3:'',
			4:'',
			5:'',
			6:'',
			7:'',
			8:'',
			9:'',
			10:'',
			11:''
			});
		this.colorBar.setBodyStyle('background-color: transparent; background-image: url(/framework/images/t.gif); background-repeat: no-repeat;');
		this.middle.getEl().setHTML('<table style="width:100%;height:100%;"><tr><td style="padding:5 0 0 0;"><img style="padding-left:60px;" src="/framework/images/t.gif"></td></tr></table>')
	}
});